﻿/*
Copyright Danal Technology Inc. 2005
For instructional purposes only, not 
meant for production use.
*/



#region Using directives

using System;
using System.Collections.Generic;
using System.Text;

#endregion
using System.Reflection;
using System.Data.SqlClient;
using System.IO;
namespace DurationClient
{
    class Program
    {
        static Program()
        {
            AppDomain.CurrentDomain.AssemblyResolve
                += new ResolveEventHandler(ResolveDuration);
        }
        static Assembly ResolveDuration(Object sender, ResolveEventArgs args)
        {
            string name = "Duration, Version=1.0.0.0, Culture=neutral, PublicKeyToken=null";
            if (args.Name == name)
            {
                using (SqlConnection conn = new SqlConnection(
                    "server=localhost;database=test1;integrated security=true"))
                {
                    using (SqlCommand cmd = new SqlCommand
                        ("select dbo.GetTimeDurationAssembly()", conn))
                    {
                        conn.Open();
                        byte[] asmBytes = (byte[])cmd.ExecuteScalar();
                        Assembly asm = Assembly.Load(asmBytes);
                        return asm;
                    }
                }
            }
            return null;
        }
        static void Main(string[] args)
        {

            using (SqlConnection conn = new SqlConnection("server=localhost;database=test1;integrated security=true"))
            {
                using (SqlCommand cmd = new SqlCommand("select Duration from Durations", conn))
                {
                    conn.Open();
                    SqlDataReader rdr = cmd.ExecuteReader();
                    Byte[] timeDurationBytes = new Byte[100];
                    MemoryStream memoryStream = new MemoryStream(timeDurationBytes);
                    BinaryReader binaryReader = new BinaryReader(memoryStream);
                    TimeDuration td1 = new TimeDuration();
                    while (rdr.Read())
                    {
                        if (!rdr.IsDBNull(0))
                        {
                            rdr.GetBytes(0, 0, timeDurationBytes, 0, timeDurationBytes.Length);
                            memoryStream.Position = 0L;
                            td1.Read(binaryReader);
                            Console.WriteLine(td1);
                        }
                    }
                    binaryReader.Close();
                }
            }
            Console.WriteLine("}}}}}}}}}");
            using (SqlConnection conn = new SqlConnection("server=localhost;database=test1;integrated security=true"))
            {
                using (SqlCommand cmd = new SqlCommand("select Duration from Durations", conn))
                {
                    conn.Open();
                    SqlDataReader rdr = cmd.ExecuteReader();
                    Byte[] timeDurationBytes = new Byte[100];
                    MemoryStream memoryStream = new MemoryStream(timeDurationBytes);
                    BinaryReader binaryReader = new BinaryReader(memoryStream);
                    TimeDuration td1 = new TimeDuration();
                    while (rdr.Read())
                    {
                        TimeDuration td;
                        if (!rdr.IsDBNull(0))
                        {
                            td = (TimeDuration)rdr[0];
                            Console.WriteLine(td.ToString());
                            TimeSpan ts = (TimeSpan)td;
                            Console.WriteLine(ts);
                            rdr.GetBytes(0, 0, timeDurationBytes, 0, timeDurationBytes.Length);
                            memoryStream.Position = 0L;
                            td1.Read(binaryReader);
                            Console.WriteLine(td1);
                        }
                    }
                    binaryReader.Close();
                    Console.WriteLine("~~~~~~~~~~~~~~~~~");
                    TimeDuration td3 = TimeSpan.Parse("5.6:7:8");
                    Console.WriteLine(td3);
                    TimeDuration td4 = (TimeSpan)td3 + TimeSpan.Parse("1");
                    Console.WriteLine(td4);
                    TimeSpan ts5 = td4;
                    Console.WriteLine(ts5);

                }
            }
            Console.WriteLine("[~~~~~~~~~~~~~~~~~~~~~~~");
            using (SqlConnection conn = new SqlConnection("server=localhost;database=test1;integrated security=true"))
            {
                using (SqlCommand cmd = new 
                    SqlCommand("select Duration from Durations", conn))
                {
                    conn.Open();
                    SqlDataReader rdr = cmd.ExecuteReader();
                    while (rdr.Read())
                    {
                        if (!rdr.IsDBNull(0))
                        {
                            TimeDuration td = (TimeDuration)rdr[0];
                            Console.WriteLine(td.ToString());
                        }
                    }
                }
            }
        }
    }
}
