SELECT
 SUM(CASE WHEN ProductID = 316 THEN Quantity END) AS Blade,
 SUM(CASE WHEN ProductID = 331 THEN Quantity END) AS [Fork End],
 SUM(CASE WHEN ProductID = 332 THEN Quantity END) AS Freewheel,
 SUM(CASE WHEN ProductID = 527 THEN Quantity END) AS Spokes,
 SUM(CASE WHEN ProductID = 529 THEN Quantity END) AS Stem
FROM Production.ProductInventory


-- group on columns not in IN clause (none in this case)
-- produce one column for each member in IN clause
-- apply aggregate function

SELECT [316] AS Blade, [331] AS [Fork End], 
       [332] AS Freewheel, [527] AS Spokes, [529] AS Stem
FROM 
   (SELECT ProductID, Quantity 
	FROM Production.ProductInventory) AS pinv
   PIVOT
   (
      SUM (Quantity) 
      FOR ProductID IN ([316], [331], [332], [527], [529])
   ) AS pvt;
GO
