

CREATE TABLE partsTree (
 id int,
 parent int,
 amount decimal(10,2)
)

INSERT partsTree VALUES(1, NULL, 10.00)
INSERT partsTree VALUES(2, 1, 1.11)
INSERT partsTree VALUES(3, 1, 1.23)
INSERT partsTree VALUES(4, 2, 0.42)
INSERT partsTree VALUES(5, 2, 0.45)
INSERT partsTree VALUES(6, 3, 0.99)
INSERT partsTree VALUES(7, 4, 0.06)

DECLARE @start int;
SET @start = 3;

WITH descendant(parent, id, amount) AS
(SELECT parent, id, amount 
  FROM partsTree WHERE id = @start
UNION ALL
SELECT P.parent, P.id, P.amount 
 FROM partsTree AS P INNER JOIN
 descendant AS A ON P.parent = A.id
)
SELECT id FROM descendant
