
USE SodaDB
GO

-- Step 1 - send a mesage
--

DECLARE @h UNIQUEIDENTIFIER;
-- hard code this for now
DECLARE @invreq XML;
SET @invreq = '
<InvRequest>
  <Product>1040</Product>
  <Quantity>3</Quantity>
</InvRequest>';

BEGIN TRY
BEGIN TRANSACTION;
BEGIN DIALOG CONVERSATION @h
 FROM SERVICE InvInitiator_L5A
 TO SERVICE 'InvService_L5A'
 ON CONTRACT InvContract_L5A
 WITH ENCRYPTION = OFF;

-- request for product 1040
SEND ON CONVERSATION @h 
 MESSAGE TYPE InvRequestMsg_L5A (@invreq);
COMMIT;
END TRY
BEGIN CATCH
	PRINT ERROR_MESSAGE()
    ROLLBACK;
END CATCH
GO

--
-- Step 2: Receive message and return the reply
-- This happens at the target. Just send <OK/> this time.
--

DECLARE @h UNIQUEIDENTIFIER;
DECLARE @invreq XML;
DECLARE @invresp XML

BEGIN TRANSACTION;
RECEIVE TOP(1)
 @invreq = CAST(message_body AS XML),
 @h = conversation_handle
 FROM InvRequestQueue_L5A;
PRINT CONVERT(VARCHAR(4000), @invreq);
SEND ON CONVERSATION @h
 MESSAGE TYPE InvResponseMsg_L5A ('<OK/>');
END CONVERSATION @h
COMMIT;
GO

--
-- Step 3: Receive the response and end the conversation
-- This happens at the initiator.
--

DECLARE @h UNIQUEIDENTIFIER;
DECLARE @resp XML;

BEGIN TRANSACTION;
RECEIVE TOP(1)
 @resp = CAST(message_body AS XML),
 @h = conversation_handle
 FROM InvResponseQueue_L5A;
PRINT CONVERT(VARCHAR(10),@resp);
-- You don't need to read the end conversation message
-- You can decide to unconditionally end the conversation
END CONVERSATION @h
COMMIT;
GO
