-- Run create database here if you need to regenerate the database

USE SodaDB
GO

IF EXISTS (SELECT * FROM sys.procedures
           WHERE name = 'decrement_inventory' AND type = 'P')
DROP PROCEDURE decrement_inventory
GO

CREATE PROCEDURE decrement_inventory
AS
DECLARE @c UNIQUEIDENTIFIER;
DECLARE @h UNIQUEIDENTIFIER;
DECLARE @m XML;
DECLARE @t NVARCHAR(128);

WHILE 1 = 1
BEGIN

BEGIN TRANSACTION
WAITFOR(
   GET CONVERSATION GROUP @c FROM InvRequestQueue_L5A),
   TIMEOUT 100 ;

IF @c IS NULL 
  BEGIN
   ROLLBACK TRANSACTION;
   BREAK;
  END

WHILE 1 = 1
BEGIN
	RECEIVE TOP(1) 
        @h=conversation_handle, 
        @t=message_type_name,
		@m=CAST(message_body as XML) 
     FROM InvRequestQueue_L5A 
     WHERE conversation_group_id = @c;

    IF @@rowcount <> 1 
		BREAK;
    IF @t = N'http://schemas.microsoft.com/SQL/ServiceBroker/EndDialog'
    OR @t = N'http://schemas.microsoft.com/SQL/ServiceBroker/Error' 
    BEGIN 
		END CONVERSATION @h WITH CLEANUP;
        CONTINUE
    END
    ELSE
    IF @t = N'InvRequestMsg_L5A'
    BEGIN
		-- Need more error handling here
        -- Or message validation using XML Schema 
		UPDATE	inventory 
		SET		units_in_stock = units_in_stock - 3
		WHERE	product_id = 1040; 
        -- Processed message, now end conversation
        END CONVERSATION @h;
    END
END
COMMIT TRANSACTION;
END
GO

-- 
-- Turn on activation
--

ALTER QUEUE InvRequestQueue_L5A WITH ACTIVATION 
  (STATUS=ON,
   PROCEDURE_NAME=decrement_inventory,
   MAX_QUEUE_READERS=5,
   EXECUTE AS SELF
  )
go



