USE SodaDB
GO

--
-- We're replacing a 
-- Traditional transaction update orders and inventory
-- see if this works
--
DECLARE @orderform XML

BEGIN TRANSACTION
	INSERT INTO orders VALUES(347, GETDATE()) 
	INSERT INTO order_form VALUES(SCOPE_IDENTITY(), @orderform);

	UPDATE	inventory 
	SET		units_in_stock = units_in_stock - 3
	WHERE	product_id = 1040;
COMMIT
go

SELECT * FROM inventory
go

-- END TRADITIONAL TRANSACTION
IF EXISTS (SELECT * FROM sys.procedures
           WHERE name = 'update_inventory' AND type = 'P')
DROP PROCEDURE update_inventory
GO

-- Encapsulate the broker step into a stored procedure
CREATE PROCEDURE update_inventory(@productid INT, @units_ordered INT)
AS
DECLARE @h UNIQUEIDENTIFIER;
-- hard code this for now
DECLARE @invreq XML;
SET @invreq = '
<InvRequest>
  <Product>1040</Product>
  <Quantity>3</Quantity>
</InvRequest>';

BEGIN TRY
BEGIN TRANSACTION;
BEGIN DIALOG CONVERSATION @h
 FROM SERVICE InvInitiator_L5A
 TO SERVICE 'InvService_L5A'
 ON CONTRACT InvContract_L5A
 WITH ENCRYPTION = OFF;

-- request for product 1040
SEND ON CONVERSATION @h 
 MESSAGE TYPE InvRequestMsg_L5A (@invreq);
COMMIT;
END TRY
BEGIN CATCH
	PRINT ERROR_MESSAGE()
    ROLLBACK;
END CATCH
GO

--
-- Rewrite initiator for process into procedure
--

DECLARE @i INT
SET @i = 1
WHILE @i < 1000
 BEGIN
	DECLARE @orderform XML

	BEGIN TRANSACTION
		INSERT INTO orders VALUES(347, GETDATE()) 
		INSERT INTO order_form VALUES(SCOPE_IDENTITY(), @orderform);
		EXECUTE update_inventory 1040, 3
    COMMIT
    SET @i = @i + 1
 END
go

-- check inventory
SELECT * FROM inventory
go