USE SodaDB
GO

IF EXISTS (SELECT * FROM sys.procedures
           WHERE name = 'inventory_response' AND type = 'P')
DROP PROCEDURE inventory_response
GO

CREATE PROCEDURE inventory_response
AS
DECLARE @c UNIQUEIDENTIFIER;
DECLARE @h UNIQUEIDENTIFIER;
DECLARE @m XML;
DECLARE @t NVARCHAR(128);

WHILE 1 = 1
BEGIN

BEGIN TRANSACTION
WAITFOR(
   GET CONVERSATION GROUP @c FROM InvResponseQueue_L5A),
   TIMEOUT 100 ;

IF @c IS NULL 
  BEGIN
   ROLLBACK TRANSACTION;
   BREAK;
  END

WHILE 1 = 1
BEGIN
	RECEIVE TOP(1) 
        @h=conversation_handle, 
        @t=message_type_name,
		@m=CAST(message_body as XML) FROM InvResponseQueue_L5A 
     WHERE conversation_group_id = @c;

    IF @@rowcount <> 1 
		BREAK;
    IF @t = N'http://schemas.microsoft.com/SQL/ServiceBroker/EndDialog'
    OR @t = N'http://schemas.microsoft.com/SQL/ServiceBroker/Error' 
    BEGIN 
		END CONVERSATION @h;
        CONTINUE
    END

	-- update order inventory request status (in order_line_item) here
	-- code elided

END
COMMIT TRANSACTION;
END
go

ALTER QUEUE InvResponseQueue_L5A WITH ACTIVATION 
  (STATUS=ON,
   PROCEDURE_NAME=inventory_response,
   MAX_QUEUE_READERS=5,
   EXECUTE AS SELF
  )
go