using System;
using System.Threading;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using InventoryNamespace;
using System.Data.SqlClient;

namespace InventoryServer
{
	/// <summary>
	/// Summary description for Form1.
	/// </summary>
	public class InventoryServer : System.Windows.Forms.Form
	{
		#region Background Thread

		//Worker Thread
		internal AutoResetEvent shutdown;
		private System.Windows.Forms.TextBox txtMain;
		private System.Windows.Forms.Button btnClear;
        private TableLayoutPanel tableLayoutPanel1;
        private Label label1;

		#endregion
		private Inventory inventory;
		private Thread ssbPump;

		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public InventoryServer()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			shutdown= new AutoResetEvent(false);
			logCounter = 0;
			//Start the worker thread
			ThreadStart worker = new ThreadStart(this.ProcessOrders);
			ssbPump = new Thread(worker);
			ssbPump.Start();
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

        #region Windows Form Designer generated code
        /// <summary>
        /// Required method for Designer support - do not modify
        /// the contents of this method with the code editor.
        /// </summary>
        private void InitializeComponent()
        {
			this.txtMain = new System.Windows.Forms.TextBox();
			this.label1 = new System.Windows.Forms.Label();
			this.tableLayoutPanel1 = new System.Windows.Forms.TableLayoutPanel();
			this.btnClear = new System.Windows.Forms.Button();
			this.tableLayoutPanel1.SuspendLayout();
			this.SuspendLayout();
			// 
			// txtMain
			// 
			this.txtMain.BackColor = System.Drawing.Color.PeachPuff;
			this.txtMain.Dock = System.Windows.Forms.DockStyle.Fill;
			this.txtMain.Font = new System.Drawing.Font("Microsoft Sans Serif", 14F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
			this.txtMain.ForeColor = System.Drawing.Color.Black;
			this.txtMain.Location = new System.Drawing.Point(3, 43);
			this.txtMain.Multiline = true;
			this.txtMain.Name = "txtMain";
			this.txtMain.ReadOnly = true;
			this.txtMain.ScrollBars = System.Windows.Forms.ScrollBars.Both;
			this.txtMain.Size = new System.Drawing.Size(633, 331);
			this.txtMain.TabIndex = 0;
			// 
			// label1
			// 
			this.label1.Anchor = System.Windows.Forms.AnchorStyles.None;
			this.label1.AutoSize = true;
			this.label1.Font = new System.Drawing.Font("Times New Roman", 27.75F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
			this.label1.Location = new System.Drawing.Point(194, 0);
			this.label1.Name = "label1";
			this.label1.Size = new System.Drawing.Size(251, 40);
			this.label1.TabIndex = 2;
			this.label1.Text = "Inventory Server";
			// 
			// tableLayoutPanel1
			// 
			this.tableLayoutPanel1.ColumnCount = 1;
			this.tableLayoutPanel1.ColumnStyles.Add(new System.Windows.Forms.ColumnStyle());
			this.tableLayoutPanel1.Controls.Add(this.label1, 0, 0);
			this.tableLayoutPanel1.Controls.Add(this.txtMain, 0, 1);
			this.tableLayoutPanel1.Controls.Add(this.btnClear, 0, 2);
			this.tableLayoutPanel1.Dock = System.Windows.Forms.DockStyle.Fill;
			this.tableLayoutPanel1.Location = new System.Drawing.Point(0, 0);
			this.tableLayoutPanel1.Name = "tableLayoutPanel1";
			this.tableLayoutPanel1.RowCount = 3;
			this.tableLayoutPanel1.RowStyles.Add(new System.Windows.Forms.RowStyle(System.Windows.Forms.SizeType.Absolute, 40F));
			this.tableLayoutPanel1.RowStyles.Add(new System.Windows.Forms.RowStyle(System.Windows.Forms.SizeType.Percent, 100F));
			this.tableLayoutPanel1.RowStyles.Add(new System.Windows.Forms.RowStyle(System.Windows.Forms.SizeType.Absolute, 40F));
			this.tableLayoutPanel1.Size = new System.Drawing.Size(639, 417);
			this.tableLayoutPanel1.TabIndex = 4;
			// 
			// btnClear
			// 
			this.btnClear.Dock = System.Windows.Forms.DockStyle.Right;
			this.btnClear.Location = new System.Drawing.Point(548, 380);
			this.btnClear.Name = "btnClear";
			this.btnClear.Size = new System.Drawing.Size(88, 34);
			this.btnClear.TabIndex = 3;
			this.btnClear.Text = "Clear";
			this.btnClear.Click += new System.EventHandler(this.btnClear_Click);
			// 
			// InventoryServer
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(639, 417);
			this.Controls.Add(this.tableLayoutPanel1);
			this.Name = "InventoryServer";
			this.Text = "Inventory Server";
			this.FormClosing += new System.Windows.Forms.FormClosingEventHandler(this.InventoryServer_FormClosing);
			this.tableLayoutPanel1.ResumeLayout(false);
			this.tableLayoutPanel1.PerformLayout();
			this.ResumeLayout(false);

        }
        #endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			//Start UI
			InventoryServer ins = new InventoryServer();
			Application.Run(ins);
			ins.ssbPump.Join();
		}

		private void ProcessOrders()
		{
			Inventory.pLogInfo li = new Inventory.pLogInfo(this.LogInfo);
			inventory = new Inventory();
			try
			{
				inventory.ProcessOrders(shutdown, li);
				this.Invoke(new EventHandler(delegate {this.Close();}));
			}
			catch (SqlException sqe)
			{
				MessageBox.Show("SqlClient threw an exception: " + sqe.Message);
			}
			return;
		}

		#region Status Logging

		private void btnClear_Click(object sender, System.EventArgs e)
		{
			txtMain.Text="";
		}

		private void LogInfo(string msg)
		{
			txtMain.Invoke(new EventHandler(delegate { txtMain.Text += msg + "\xD\xA"; txtMain.Select(txtMain.Text.Length, 0);  }));
			logCounter++;
			if (logCounter % 5 == 0)
				txtMain.Invoke(new EventHandler(delegate { txtMain.Text += "-----" + "\xD\xA"; txtMain.Select(txtMain.Text.Length, 0); }));
		}
		private int logCounter;
		#endregion

		#region Shutdown Thread Event
		private void InventoryServer_FormClosing(object sender, FormClosingEventArgs e)
		{
			shutdown.Set();
			inventory.Shutdown();
		}
		#endregion
	}
}
