-- Diagnostic queries useful during transactions

-- outstanding locks, any version
sp_lock
go

-- includes BlkBy (blocked by) column
sp_who2
go

-- includes extra wait columns
master..sp_who3
go

-- SQL Server 2005 Dynamic Management Views
-- sys.dm_tran%

-- sp_lock replacement
-- active lock manager resources
select * from sys.dm_tran_locks

-- per-instance transaction info
select * from sys.dm_tran_active_transactions

-- state of transaction in current session (1 row)
select * from sys.dm_tran_current_transaction

-- transactions at a database level
select * from sys.dm_tran_database_transactions

-- info to correlate transactions and session
select * from sys.dm_tran_session_transactions

-- Snapshot transactions only

-- all tx that can generate row versions
select * from sys.dm_tran_active_snapshot_database_transactions

-- active transactions for current snapshot transaction
select * from sys.dm_tran_current_snapshot

-- objects producing the most versions in version store
select * from sys.dm_tran_top_version_generators

-- sequence numbers that are active when transaction starts
select * from sys.dm_tran_transactions_snapshot

-- displays are rows in the version store
select * from sys.dm_tran_version_store
